;fszm_a.asm: fordulatszmmr? 60 impulzus/fordulat bemenethez, 1 s kapuid?vel,
;ngyjegy? multiplex LED kijelz?vel, fosc=4 MHz (HS)	

	list p=16F1619
	list r=dec
	#include <p16F1619.inc>
	
	__CONFIG _CONFIG1, _FOSC_HS & _PWRTE_OFF & _MCLRE_OFF & _CP_ON & _BOREN_ON & _CLKOUTEN_OFF & _IESO_ON & _FCMEN_OFF
	__CONFIG _CONFIG2, _WRT_OFF & _PPS1WAY_OFF & _PLLEN_OFF & _STVREN_OFF & _BORV_LO & _LVP_OFF
	__CONFIG _CONFIG3, _WDTE_OFF
	
	#include <prlx.inc>
led	equ	3	; ez a tizedespont bitcme, nincs hasznlatban	
mask0	equ	80h	; ezresek
mask1	equ	40h	; szzasok
mask2	equ	20h	; tzesek 
mask3	equ	10h	; egyesek
t_div3	equ	20	; gomb oszt, gyors reakcihoz
	
	cblock	0x20
	f1		; csak a nulls lapra j jelzbitek
	g_cnt		; gomb szmll
	g_old		; gomb elz
	div_s:3		; oszt ment (tovbbfejlesztshez)
	f_dec:4		; fordulatszm decimlisan
	endc
	
	cblock	0x70
	ah
	al
	bh
	bla	   ; bl lett volna, de az foglalt szval tkzik
	ch
	cl
	flags		; jelzbitek, ksbb rszletezve
	aux		; ltalnos segdregiszter
	gombok		; neglt gombkp
	endc

	#define keyin	porta,3	; gomb mux bemenet
	#define van	flags,0	; van gombnyoms
	#define	nincs	flags,1	; volt sznet
	#define	nlead	flags,2	; rtktelen nullk elnyomshoz
	
	cblock	0x120	; mert lata, latb, latc oldala
	m4reg		; mux regiszter (ugrcm)
	sbuf:4		; a ngy 7 szegmenses szmjegy, legnagyobb el?l
	endc
	
	org	0
	clrf	intcon
	clrf	pclath
	clrf	fsr0h
	goto	start
	
	org	4
	banksel	0
	pagesel	0
	goto	its

	; szegmenstbla
s7tbl	; a hardverhez igaztva, 0-9, mnusz, nagy P, nagy A, resek
	dt	0x77, 0x44, 0xb5, 0xd5, 0xc6, 0xd3, 0xf3, 0x45
	dt	0xf7, 0xd7, 0x80, 0xa7, 0xe7, 0, 0, 0 
its
	jnb	pir4,smt1if,t2isr
	bcf	pir4,smt1if
	jb	porta,2,nagy
	banksel	smt1pru
	clrf	smt1pru
	movlw	0x42
	movwf	smt1prh
	movlw	0x3f
	movwf	smt1prl
	retfie
nagy
	banksel	smt1pru
	movlw	0x0f
	movwf	smt1pru	
	movlw	0x42
	movwf	smt1prh
	movlw	0x3f
	movwf	smt1prl
	retfie
t2isr
	banksel	latc
	movf	m4reg,w		; soron kvetkez g relatv cme
	brw			; ugrs (pc+1+W) cmre 
nullas	
	movlw	low (egyes-nullas)	; hogy a kvetkez krben a kvetkez
	movwf	m4reg		; ugrcmet vlassza
	movlw	0x00		; kiolt bjt rtke
	movwf	latc		; kiolts katdban a vlts idejre
	movlw	mask0		; szmjegykijell sz tltse 1. jegyhez
	movwf	latb		; szmjegykijells, gomb strobe 	
	movf	sbuf,w
	movwf	latc		; els szmjegy kdja a c portra
	banksel	0
	nop
	nop
	bsf	status,c    ; ezalatt kapott 6 us-ot, hogy stabilizldjon
	btfsc	porta,3	    ; mux gomb bit beolvassa
	bcf	status,c
	rlf	gombok,f
	goto	raer
egyes
	movlw	low (kettes-nullas)
	movwf	m4reg		; kvetkez ugrcm elksztse
	movlw	0x00
	movwf	latc
	movlw	mask1		; 2. jegyhez
	movwf	latb
	movf	sbuf+1,w	
	movwf	latc		; msodik
	banksel	0
	nop
	nop
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f
	goto	raer
kettes
	movlw	low (harmas-nullas)
	movwf	m4reg
	movlw	0x00
	movwf	latc
	movlw	mask2
	movwf	latb
	movf	sbuf+2,w
	movwf	latc
	banksel	0
	nop
	nop
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f
	goto	raer
harmas
	movlw	low (nullas-nullas)
	movwf	m4reg
	movlw	0x00
	movwf	latc
	movlw	mask3
	movwf	latb
	movf	sbuf+3,w
	movwf	latc
	banksel	0
	nop
	nop
	bsf	status,c
	btfsc	porta,3
	bcf	status,c
	rlf	gombok,f	; 4 krnknt 4 gomb beolvasva
	movlw	15
	andwf	gombok,f	; csak 4 bit maradhat
; gombok 3..0 tartalmazza az aktulis gombllapotot (nyomva=1)	
	djnz	g_cnt,raer
	movlw	t_div3		; ha g_cnt elfogyott:
	movwf	g_cnt
	cjne	gombok,g_old,nog
	movf	gombok,f	; s kett megegyezett, akkor
	btfss	status,z
	bsf	van		; vagy gombok miatt "van"
nog
	movf	gombok,f
	btfsc	status,z
	bsf	nincs		; vagy egyik sincs miatt nincs 1 lesz
	goto	atir
atir
	movf	gombok,w	; s az j meg lesz regtve
	movwf	g_old
; ez a megszakts cserli SMT1PR-t s multiplexel. Gombot 
; is gyjt, de azt nem nzi senki.	
raer
	bcf	pir1,tmr2if
	retfie

start
	banksel	lata
	clrf	lata
	clrf	latb
	clrf	latc
	banksel	trisa
	movlw	0x33
	movwf	trisa
	clrf	trisb
	clrf	trisc
	bcf	option_reg,7
	movlw	0x68
	movwf	osccon	; bell a 4 MHz kvarc nlkl is, csak pontatlanabb
	banksel	ansela
	clrf	ansela
	clrf	anselb
	clrf	anselc
	banksel	wpua
	movlw	8
	movwf	wpua
	clrf	wpub
	clrf	wpuc
	banksel	t1gpps
	movlw	1
	movwf	t1gpps
	clrf	t1ckipps
	banksel	ra2pps
	movlw	4
	movwf	ra2pps
	banksel	smt1con0
	movlw	0x80
	movwf	smt1con0
	clrf	smt1con1	; mg nem indul. A 7-es bit a go.
	clrf	smt1stat
	movlw	1
	movwf	smt1clk
	clrf	smt1win
	clrf	smt1sig
	movlw	0x00
	movwf	smt1pru
	movlw	0x42
	movwf	smt1prh
	movlw	0x3f
	movwf	smt1prl
	clrf	smt1tmru
	clrf	smt1tmrh
	clrf	smt1tmrl
	banksel	pie4
	bsf	pie4,smt1ie	; megszaktsban kezelem
	banksel	clc1con
	clrf	clc1pol
	movlw	0x13
	movwf	clc1sel0
	movlw	4
	movwf	clc1sel1
	movlw	8
	movwf	clc1sel2
	movwf	clc1sel3
	movlw	2
	movwf	clc1gls0
	movlw	4
	movwf	clc1gls1
	clrf	clc1gls2
	clrf	clc1gls3
	movlw	0x84
	movwf	clc1con
	bsf	clc1pol,2 ; clear latch
	nop
	bcf	clc1pol,2 ; enable latch
	banksel	0	
	clrf	pir1
	clrf	t2clkcon
	clrf	t2hlt
	clrf	t2rst
	movlw	0x7c	; 4 MHz-r?l 1 ms
	movwf	t2pr
	clrf	tmr2
	movlw	0x30
	movwf	t2con
	bsf t2con,7
	banksel	pie1
	bsf	pie1,tmr2ie
	banksel	t1con
	movlw	0xc0
	movwf	t1gcon
	clrf	tmr1h
	clrf	tmr1l
	movlw	0x84
	movwf	t1con
	bsf	t1con,0
	banksel	smt1con0
	bsf	smt1con1,7
	banksel	f_dec
	movlw	0x08
	movwf	f_dec
	movwf	f_dec+1
	movwf	f_dec+2
	movwf	f_dec+3
	clrf	bla
	movlw	f_dec
	movwf	fsr0l
	movlw	4
	movwf	aux
	call	lzs ; leading zero supression
	movlw	f_dec
	movwf	fsr0l
	call	decseg
	banksel	m4reg
	clrf	m4reg
	bsf  sbuf,led
	bsf  sbuf+1,led
	bsf  sbuf+2,led
	bsf  sbuf+3,led
	banksel	0
	bcf	pir1,tmr1gif
	bsf	intcon,peie
	bsf	intcon,gie

; A kijelz stt, de az els? 4 tmr2 megszakts utn mr nem az. 
; Minden megy, az smt match s t2 krhet megszaktst. A tmr1gif-et 
; brki vizsglhatja, mert csak msodpercenknt jelentkezik.  fogja
; tlteni a tnyleges decimlis adatot, majd a szegmens regisztereket.
; Brmilyen j adat trli az adott szmjegyhez tartoz tizedespontot.	
m_loop
; mivel gombok nincsenek, ez csak akkor mkdik, amikor tmr1gif=1
	jnb	pir1,tmr1gif,m_loop
	movf	tmr1h,w
	movwf	ah
	movf	tmr1l,w
	movwf	al
	clrf	tmr1h
	clrf	tmr1l
	bcf	pir1,tmr1gif
; a kritikus rsznek ezzel vge, jhet az talakts
	call	bibc16
	swapf	ch,w
	andlw	0x0f
	movwf	f_dec
	movf	ch,w
	andlw	0x0f
	movwf	f_dec+1
	swapf	cl,w
	andlw	0x0f
	movwf	f_dec+2
	movf	cl,w
	andlw	0x0f
	movwf	f_dec+3
	clrf	fsr0h
	movlw	f_dec
	movwf	fsr0l
	movlw	4
	movwf	aux
	call	lzs
	movlw	f_dec
	movwf	fsr0l
	call	decseg
	banksel	sbuf
	csbl	bla,1
	bsf	sbuf+3,led
	csbl	bla,2
	bsf	sbuf+2,led
	csbl	bla,3
	bsf	sbuf+1,led
	csbl	bla,4
	bsf	sbuf,led
	banksel	0
	goto	m_loop	

; bibc16: 16 bit binrisrl 5 digit csomagolt bcd-re
; A binris Ah, Al-ben, a BCD eredmny Bl1,Ch,Cl-ben.
; Van neki 2 db munkaragiszter (szaml s Bh) ignye.
; FSR-t is hasznlja. Bels szubrutinos vltozat.
szaml   equ     aux             ; szaml igny kielgtve
bibc16
	movlw	16
	movwf   szaml
	clc
	clrf    bla              
	clrf    ch
	clrf    cl              ; eredmny helynek trlse              
bibnul
	rlf     al,f               
	rlf     ah,f              
	decf    szaml,f
	sz
	goto	bibcont
	snc
	incf	cl,f
	return
bibcont
	sc                      ; addig lpteti balra az osztandt, amg
	goto    bibnul		; egy '1' rtk bitet nem fog.
	rlf     cl,f              ; ez itt az eredmny legkisebb bjtja,
	rlf     ch,f              ; innen kezdve lpnek majd be a jegyek.
	rlf     bla,f              

	rlf     al,f              ; osztand volt
	rlf     ah,f

	rlf     cl,f              ; eredmny lesz
	rlf     ch,f
	rlf     bla,f              ; bevett 2 bitet, itt mg nincs korrekci.

	decf    szaml,f
	snz
        return                     ; kilp, ha ennyi volt
dhurok
	rlf     al,f              ; ha maradtak mg bitek:
	rlf     ah,f

	rlf     cl,f
	rlf     ch,f
	rlf     bla,f              ; tveszi, s korrigl, mg el nem fogy
	djnz    szaml,dadj      ; utols lptets utn nem korrigl ?!
	return
dadj
	movl    fsr0l,cl         ; minden eredmnybjtra bcadj
	call    bcadj
	movl    fsr0l,ch
	call    bcadj
	movl    fsr0l,bla
	call    bcadj
	goto    dhurok
; ez a bcd korrekci, amit az eredmny minden egyes bjtjn elvgez,
bcadj
	movlw	3
	addwf	indf0,w
	movwf   bh
	snb     bh,3
	movwf   indf0
	movlw	30h
	addwf	indf0,w
	movwf   bh
	snb     bh,7
	movwf   indf0
	return

lzs
	bcf     nlead	; leading zero supression (indirekt mezre)
	movf	bla,f
	sz
	bsf nlead	; ha bla nem 0, nem olt ki semmit
lzslp
	decf	aux,w 	; aux-ban az egsz szmjegyek szmt kapja
        snz
        bsf     nlead	; ha utols, a nullt is ki kell rni
        movf    indf0,f
        sz
        bsf     nlead	; az els nem nulltl kezdve mindent kir
        movf    indf0,w
        sb      nlead
        movlw	15	; a karaktergenertor 15-se sett, mint Lajos, a hhr
        movwi	fsr0++
        djnz    aux,lzslp
        return

decseg				; indirekt:4-b?l SBUF...SBUF+3
	banksel	sbuf
	moviw	fsr0++
	addlw	low s7tbl	
	callw
	movwf	sbuf
	moviw	fsr0++
	addlw	low s7tbl
	callw
	movwf	sbuf+1
	moviw	fsr0++
	addlw	low s7tbl
	callw
	movwf	sbuf+2
	moviw	fsr0++
	addlw	low s7tbl
	callw
	movwf	sbuf+3
	banksel 0
	return
	end